<?php

namespace rdyescapiacontent\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRateRangeType ArrayType
 * @subpackage Arrays
 */
class ArrayOfRateRangeType extends AbstractStructArrayBase
{
    /**
     * The RateRange
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\RateRangeType[]
     */
    public $RateRange;
    /**
     * Constructor method for ArrayOfRateRangeType
     * @uses ArrayOfRateRangeType::setRateRange()
     * @param \rdyescapiacontent\StructType\RateRangeType[] $rateRange
     */
    public function __construct(array $rateRange = array())
    {
        $this
            ->setRateRange($rateRange);
    }
    /**
     * Get RateRange value
     * @return \rdyescapiacontent\StructType\RateRangeType[]|null
     */
    public function getRateRange()
    {
        return $this->RateRange;
    }
    /**
     * This method is responsible for validating the values passed to the setRateRange method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRateRange method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRateRangeForArrayConstraintsFromSetRateRange(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRateRangeTypeRateRangeItem) {
            // validation for constraint: itemType
            if (!$arrayOfRateRangeTypeRateRangeItem instanceof \rdyescapiacontent\StructType\RateRangeType) {
                $invalidValues[] = is_object($arrayOfRateRangeTypeRateRangeItem) ? get_class($arrayOfRateRangeTypeRateRangeItem) : sprintf('%s(%s)', gettype($arrayOfRateRangeTypeRateRangeItem), var_export($arrayOfRateRangeTypeRateRangeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RateRange property can only contain items of type \rdyescapiacontent\StructType\RateRangeType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RateRange value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\RateRangeType[] $rateRange
     * @return \rdyescapiacontent\ArrayType\ArrayOfRateRangeType
     */
    public function setRateRange(array $rateRange = array())
    {
        // validation for constraint: array
        if ('' !== ($rateRangeArrayErrorMessage = self::validateRateRangeForArrayConstraintsFromSetRateRange($rateRange))) {
            throw new \InvalidArgumentException($rateRangeArrayErrorMessage, __LINE__);
        }
        $this->RateRange = $rateRange;
        return $this;
    }
    /**
     * Add item to RateRange value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\RateRangeType $item
     * @return \rdyescapiacontent\ArrayType\ArrayOfRateRangeType
     */
    public function addToRateRange(\rdyescapiacontent\StructType\RateRangeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\RateRangeType) {
            throw new \InvalidArgumentException(sprintf('The RateRange property can only contain items of type \rdyescapiacontent\StructType\RateRangeType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RateRange[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \rdyescapiacontent\StructType\RateRangeType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \rdyescapiacontent\StructType\RateRangeType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \rdyescapiacontent\StructType\RateRangeType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \rdyescapiacontent\StructType\RateRangeType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \rdyescapiacontent\StructType\RateRangeType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RateRange
     */
    public function getAttributeName()
    {
        return 'RateRange';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\ArrayType\ArrayOfRateRangeType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
