<?php

namespace rdyescapiacontent\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRoutingHopTypeRoutingHop ArrayType
 * @subpackage Arrays
 */
class ArrayOfRoutingHopTypeRoutingHop extends AbstractStructArrayBase
{
    /**
     * The RoutingHop
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\RoutingHop[]
     */
    public $RoutingHop;
    /**
     * Constructor method for ArrayOfRoutingHopTypeRoutingHop
     * @uses ArrayOfRoutingHopTypeRoutingHop::setRoutingHop()
     * @param \rdyescapiacontent\StructType\RoutingHop[] $routingHop
     */
    public function __construct(array $routingHop = array())
    {
        $this
            ->setRoutingHop($routingHop);
    }
    /**
     * Get RoutingHop value
     * @return \rdyescapiacontent\StructType\RoutingHop[]|null
     */
    public function getRoutingHop()
    {
        return $this->RoutingHop;
    }
    /**
     * This method is responsible for validating the values passed to the setRoutingHop method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoutingHop method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoutingHopForArrayConstraintsFromSetRoutingHop(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRoutingHopTypeRoutingHopRoutingHopItem) {
            // validation for constraint: itemType
            if (!$arrayOfRoutingHopTypeRoutingHopRoutingHopItem instanceof \rdyescapiacontent\StructType\RoutingHop) {
                $invalidValues[] = is_object($arrayOfRoutingHopTypeRoutingHopRoutingHopItem) ? get_class($arrayOfRoutingHopTypeRoutingHopRoutingHopItem) : sprintf('%s(%s)', gettype($arrayOfRoutingHopTypeRoutingHopRoutingHopItem), var_export($arrayOfRoutingHopTypeRoutingHopRoutingHopItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoutingHop property can only contain items of type \rdyescapiacontent\StructType\RoutingHop, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoutingHop value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\RoutingHop[] $routingHop
     * @return \rdyescapiacontent\ArrayType\ArrayOfRoutingHopTypeRoutingHop
     */
    public function setRoutingHop(array $routingHop = array())
    {
        // validation for constraint: array
        if ('' !== ($routingHopArrayErrorMessage = self::validateRoutingHopForArrayConstraintsFromSetRoutingHop($routingHop))) {
            throw new \InvalidArgumentException($routingHopArrayErrorMessage, __LINE__);
        }
        $this->RoutingHop = $routingHop;
        return $this;
    }
    /**
     * Add item to RoutingHop value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\RoutingHop $item
     * @return \rdyescapiacontent\ArrayType\ArrayOfRoutingHopTypeRoutingHop
     */
    public function addToRoutingHop(\rdyescapiacontent\StructType\RoutingHop $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\RoutingHop) {
            throw new \InvalidArgumentException(sprintf('The RoutingHop property can only contain items of type \rdyescapiacontent\StructType\RoutingHop, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoutingHop[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \rdyescapiacontent\StructType\RoutingHop|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \rdyescapiacontent\StructType\RoutingHop|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \rdyescapiacontent\StructType\RoutingHop|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \rdyescapiacontent\StructType\RoutingHop|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \rdyescapiacontent\StructType\RoutingHop|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoutingHop
     */
    public function getAttributeName()
    {
        return 'RoutingHop';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\ArrayType\ArrayOfRoutingHopTypeRoutingHop
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
