<?php

namespace rdyescapiacontent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Contact StructType
 * @subpackage Structs
 */
class Contact extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\PersonNameType
     */
    public $Name;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\EmailType[]
     */
    public $Email;
    /**
     * The Telephone
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\TelephoneInfoType[]
     */
    public $Telephone;
    /**
     * The PreferredContactMethod
     * @var string
     */
    public $PreferredContactMethod;
    /**
     * The IPAddress
     * @var string
     */
    public $IPAddress;
    /**
     * Constructor method for Contact
     * @uses Contact::setName()
     * @uses Contact::setEmail_1()
     * @uses Contact::setTelephone()
     * @uses Contact::setPreferredContactMethod()
     * @uses Contact::setIPAddress()
     * @param \rdyescapiacontent\StructType\PersonNameType $name
     * @param \rdyescapiacontent\StructType\EmailType[] $email
     * @param \rdyescapiacontent\StructType\TelephoneInfoType[] $telephone
     * @param string $preferredContactMethod
     * @param string $iPAddress
     */
    public function __construct(\rdyescapiacontent\StructType\PersonNameType $name = null, array $email_1 = array(), array $telephone = array(), $preferredContactMethod = null, $iPAddress = null)
    {
        $this
            ->setName($name)
            ->setEmail_1($email_1)
            ->setTelephone($telephone)
            ->setPreferredContactMethod($preferredContactMethod)
            ->setIPAddress($iPAddress);
    }
    /**
     * Get Name value
     * @return \rdyescapiacontent\StructType\PersonNameType|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param \rdyescapiacontent\StructType\PersonNameType $name
     * @return \rdyescapiacontent\StructType\Contact
     */
    public function setName(\rdyescapiacontent\StructType\PersonNameType $name = null)
    {
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Email value
     * @return \rdyescapiacontent\StructType\EmailType[]|null
     */
    public function getEmail_1()
    {
        return $this->Email;
    }
    /**
     * This method is responsible for validating the values passed to the setEmail_1 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEmail_1 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEmail_1ForArrayConstraintsFromSetEmail_1(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $contactEmailItem) {
            // validation for constraint: itemType
            if (!$contactEmailItem instanceof \rdyescapiacontent\StructType\EmailType) {
                $invalidValues[] = is_object($contactEmailItem) ? get_class($contactEmailItem) : sprintf('%s(%s)', gettype($contactEmailItem), var_export($contactEmailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Email property can only contain items of type \rdyescapiacontent\StructType\EmailType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Email value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\EmailType[] $email
     * @return \rdyescapiacontent\StructType\Contact
     */
    public function setEmail_1(array $email_1 = array())
    {
        // validation for constraint: array
        if ('' !== ($email_1ArrayErrorMessage = self::validateEmail_1ForArrayConstraintsFromSetEmail_1($email_1))) {
            throw new \InvalidArgumentException($email_1ArrayErrorMessage, __LINE__);
        }
        $this->Email = $email_1;
        return $this;
    }
    /**
     * Add item to Email value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\EmailType $item
     * @return \rdyescapiacontent\StructType\Contact
     */
    public function addToEmail(\rdyescapiacontent\StructType\EmailType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\EmailType) {
            throw new \InvalidArgumentException(sprintf('The Email property can only contain items of type \rdyescapiacontent\StructType\EmailType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Email[] = $item;
        return $this;
    }
    /**
     * Get Telephone value
     * @return \rdyescapiacontent\StructType\TelephoneInfoType[]|null
     */
    public function getTelephone()
    {
        return $this->Telephone;
    }
    /**
     * This method is responsible for validating the values passed to the setTelephone method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTelephone method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTelephoneForArrayConstraintsFromSetTelephone(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $contactTelephoneItem) {
            // validation for constraint: itemType
            if (!$contactTelephoneItem instanceof \rdyescapiacontent\StructType\TelephoneInfoType) {
                $invalidValues[] = is_object($contactTelephoneItem) ? get_class($contactTelephoneItem) : sprintf('%s(%s)', gettype($contactTelephoneItem), var_export($contactTelephoneItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Telephone property can only contain items of type \rdyescapiacontent\StructType\TelephoneInfoType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Telephone value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\TelephoneInfoType[] $telephone
     * @return \rdyescapiacontent\StructType\Contact
     */
    public function setTelephone(array $telephone = array())
    {
        // validation for constraint: array
        if ('' !== ($telephoneArrayErrorMessage = self::validateTelephoneForArrayConstraintsFromSetTelephone($telephone))) {
            throw new \InvalidArgumentException($telephoneArrayErrorMessage, __LINE__);
        }
        $this->Telephone = $telephone;
        return $this;
    }
    /**
     * Add item to Telephone value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\TelephoneInfoType $item
     * @return \rdyescapiacontent\StructType\Contact
     */
    public function addToTelephone(\rdyescapiacontent\StructType\TelephoneInfoType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\TelephoneInfoType) {
            throw new \InvalidArgumentException(sprintf('The Telephone property can only contain items of type \rdyescapiacontent\StructType\TelephoneInfoType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Telephone[] = $item;
        return $this;
    }
    /**
     * Get PreferredContactMethod value
     * @return string|null
     */
    public function getPreferredContactMethod()
    {
        return $this->PreferredContactMethod;
    }
    /**
     * Set PreferredContactMethod value
     * @uses \rdyescapiacontent\EnumType\PreferredContactMethodType::valueIsValid()
     * @uses \rdyescapiacontent\EnumType\PreferredContactMethodType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $preferredContactMethod
     * @return \rdyescapiacontent\StructType\Contact
     */
    public function setPreferredContactMethod($preferredContactMethod = null)
    {
        // validation for constraint: enumeration
        if (!\rdyescapiacontent\EnumType\PreferredContactMethodType::valueIsValid($preferredContactMethod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \rdyescapiacontent\EnumType\PreferredContactMethodType', is_array($preferredContactMethod) ? implode(', ', $preferredContactMethod) : var_export($preferredContactMethod, true), implode(', ', \rdyescapiacontent\EnumType\PreferredContactMethodType::getValidValues())), __LINE__);
        }
        $this->PreferredContactMethod = $preferredContactMethod;
        return $this;
    }
    /**
     * Get IPAddress value
     * @return string|null
     */
    public function getIPAddress()
    {
        return $this->IPAddress;
    }
    /**
     * Set IPAddress value
     * @param string $iPAddress
     * @return \rdyescapiacontent\StructType\Contact
     */
    public function setIPAddress($iPAddress = null)
    {
        // validation for constraint: string
        if (!is_null($iPAddress) && !is_string($iPAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iPAddress, true), gettype($iPAddress)), __LINE__);
        }
        $this->IPAddress = $iPAddress;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\StructType\Contact
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
