<?php

namespace rdyescapiacontent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVRN_UnitStayRQ StructType
 * @subpackage Structs
 */
class EVRN_UnitStayRQ extends EVRN_BaseRQType
{
    /**
     * The UnitStay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\UnitStay[]
     */
    public $UnitStay;
    /**
     * Constructor method for EVRN_UnitStayRQ
     * @uses EVRN_UnitStayRQ::setUnitStay()
     * @param \rdyescapiacontent\StructType\UnitStay[] $unitStay
     */
    public function __construct(array $unitStay = array())
    {
        $this
            ->setUnitStay($unitStay);
    }
    /**
     * Get UnitStay value
     * @return \rdyescapiacontent\StructType\UnitStay[]|null
     */
    public function getUnitStay()
    {
        return $this->UnitStay;
    }
    /**
     * This method is responsible for validating the values passed to the setUnitStay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUnitStay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUnitStayForArrayConstraintsFromSetUnitStay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eVRN_UnitStayRQUnitStayItem) {
            // validation for constraint: itemType
            if (!$eVRN_UnitStayRQUnitStayItem instanceof \rdyescapiacontent\StructType\UnitStay) {
                $invalidValues[] = is_object($eVRN_UnitStayRQUnitStayItem) ? get_class($eVRN_UnitStayRQUnitStayItem) : sprintf('%s(%s)', gettype($eVRN_UnitStayRQUnitStayItem), var_export($eVRN_UnitStayRQUnitStayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UnitStay property can only contain items of type \rdyescapiacontent\StructType\UnitStay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UnitStay value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\UnitStay[] $unitStay
     * @return \rdyescapiacontent\StructType\EVRN_UnitStayRQ
     */
    public function setUnitStay(array $unitStay = array())
    {
        // validation for constraint: array
        if ('' !== ($unitStayArrayErrorMessage = self::validateUnitStayForArrayConstraintsFromSetUnitStay($unitStay))) {
            throw new \InvalidArgumentException($unitStayArrayErrorMessage, __LINE__);
        }
        $this->UnitStay = $unitStay;
        return $this;
    }
    /**
     * Add item to UnitStay value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\UnitStay $item
     * @return \rdyescapiacontent\StructType\EVRN_UnitStayRQ
     */
    public function addToUnitStay(\rdyescapiacontent\StructType\UnitStay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\UnitStay) {
            throw new \InvalidArgumentException(sprintf('The UnitStay property can only contain items of type \rdyescapiacontent\StructType\UnitStay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UnitStay[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\StructType\EVRN_UnitStayRQ
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
