<?php

namespace rdyescapiacontent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnitReviewType StructType
 * @subpackage Structs
 */
class UnitReviewType extends AbstractStructBase
{
    /**
     * The ReviewScore
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\ReviewScoreType[]
     */
    public $ReviewScore;
    /**
     * The ReviewComment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\ReviewCommentType[]
     */
    public $ReviewComment;
    /**
     * The ManagerResponse
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\ManagerResponseType[]
     */
    public $ManagerResponse;
    /**
     * The Title
     * @var string
     */
    public $Title;
    /**
     * The ReviewedDate
     * @var string
     */
    public $ReviewedDate;
    /**
     * The LastUpdated
     * @var string
     */
    public $LastUpdated;
    /**
     * The ReviewerID
     * @var string
     */
    public $ReviewerID;
    /**
     * The ReviewerName
     * @var string
     */
    public $ReviewerName;
    /**
     * The ReviewerCity
     * @var string
     */
    public $ReviewerCity;
    /**
     * The ReviewerState
     * @var string
     */
    public $ReviewerState;
    /**
     * The ReviewerCountry
     * @var string
     */
    public $ReviewerCountry;
    /**
     * The CheckIn
     * @var string
     */
    public $CheckIn;
    /**
     * The CheckOut
     * @var string
     */
    public $CheckOut;
    /**
     * The PropertyManagerRejected
     * @var bool
     */
    public $PropertyManagerRejected;
    /**
     * The ReservationNumber
     * @var string
     */
    public $ReservationNumber;
    /**
     * Constructor method for UnitReviewType
     * @uses UnitReviewType::setReviewScore()
     * @uses UnitReviewType::setReviewComment()
     * @uses UnitReviewType::setManagerResponse()
     * @uses UnitReviewType::setTitle()
     * @uses UnitReviewType::setReviewedDate()
     * @uses UnitReviewType::setLastUpdated()
     * @uses UnitReviewType::setReviewerID()
     * @uses UnitReviewType::setReviewerName()
     * @uses UnitReviewType::setReviewerCity()
     * @uses UnitReviewType::setReviewerState()
     * @uses UnitReviewType::setReviewerCountry()
     * @uses UnitReviewType::setCheckIn()
     * @uses UnitReviewType::setCheckOut()
     * @uses UnitReviewType::setPropertyManagerRejected()
     * @uses UnitReviewType::setReservationNumber()
     * @param \rdyescapiacontent\StructType\ReviewScoreType[] $reviewScore
     * @param \rdyescapiacontent\StructType\ReviewCommentType[] $reviewComment
     * @param \rdyescapiacontent\StructType\ManagerResponseType[] $managerResponse
     * @param string $title
     * @param string $reviewedDate
     * @param string $lastUpdated
     * @param string $reviewerID
     * @param string $reviewerName
     * @param string $reviewerCity
     * @param string $reviewerState
     * @param string $reviewerCountry
     * @param string $checkIn
     * @param string $checkOut
     * @param bool $propertyManagerRejected
     * @param string $reservationNumber
     */
    public function __construct(array $reviewScore = array(), array $reviewComment = array(), array $managerResponse = array(), $title = null, $reviewedDate = null, $lastUpdated = null, $reviewerID = null, $reviewerName = null, $reviewerCity = null, $reviewerState = null, $reviewerCountry = null, $checkIn = null, $checkOut = null, $propertyManagerRejected = null, $reservationNumber = null)
    {
        $this
            ->setReviewScore($reviewScore)
            ->setReviewComment($reviewComment)
            ->setManagerResponse($managerResponse)
            ->setTitle($title)
            ->setReviewedDate($reviewedDate)
            ->setLastUpdated($lastUpdated)
            ->setReviewerID($reviewerID)
            ->setReviewerName($reviewerName)
            ->setReviewerCity($reviewerCity)
            ->setReviewerState($reviewerState)
            ->setReviewerCountry($reviewerCountry)
            ->setCheckIn($checkIn)
            ->setCheckOut($checkOut)
            ->setPropertyManagerRejected($propertyManagerRejected)
            ->setReservationNumber($reservationNumber);
    }
    /**
     * Get ReviewScore value
     * @return \rdyescapiacontent\StructType\ReviewScoreType[]|null
     */
    public function getReviewScore()
    {
        return $this->ReviewScore;
    }
    /**
     * This method is responsible for validating the values passed to the setReviewScore method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReviewScore method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReviewScoreForArrayConstraintsFromSetReviewScore(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $unitReviewTypeReviewScoreItem) {
            // validation for constraint: itemType
            if (!$unitReviewTypeReviewScoreItem instanceof \rdyescapiacontent\StructType\ReviewScoreType) {
                $invalidValues[] = is_object($unitReviewTypeReviewScoreItem) ? get_class($unitReviewTypeReviewScoreItem) : sprintf('%s(%s)', gettype($unitReviewTypeReviewScoreItem), var_export($unitReviewTypeReviewScoreItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReviewScore property can only contain items of type \rdyescapiacontent\StructType\ReviewScoreType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReviewScore value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\ReviewScoreType[] $reviewScore
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setReviewScore(array $reviewScore = array())
    {
        // validation for constraint: array
        if ('' !== ($reviewScoreArrayErrorMessage = self::validateReviewScoreForArrayConstraintsFromSetReviewScore($reviewScore))) {
            throw new \InvalidArgumentException($reviewScoreArrayErrorMessage, __LINE__);
        }
        $this->ReviewScore = $reviewScore;
        return $this;
    }
    /**
     * Add item to ReviewScore value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\ReviewScoreType $item
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function addToReviewScore(\rdyescapiacontent\StructType\ReviewScoreType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\ReviewScoreType) {
            throw new \InvalidArgumentException(sprintf('The ReviewScore property can only contain items of type \rdyescapiacontent\StructType\ReviewScoreType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReviewScore[] = $item;
        return $this;
    }
    /**
     * Get ReviewComment value
     * @return \rdyescapiacontent\StructType\ReviewCommentType[]|null
     */
    public function getReviewComment()
    {
        return $this->ReviewComment;
    }
    /**
     * This method is responsible for validating the values passed to the setReviewComment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReviewComment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReviewCommentForArrayConstraintsFromSetReviewComment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $unitReviewTypeReviewCommentItem) {
            // validation for constraint: itemType
            if (!$unitReviewTypeReviewCommentItem instanceof \rdyescapiacontent\StructType\ReviewCommentType) {
                $invalidValues[] = is_object($unitReviewTypeReviewCommentItem) ? get_class($unitReviewTypeReviewCommentItem) : sprintf('%s(%s)', gettype($unitReviewTypeReviewCommentItem), var_export($unitReviewTypeReviewCommentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReviewComment property can only contain items of type \rdyescapiacontent\StructType\ReviewCommentType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReviewComment value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\ReviewCommentType[] $reviewComment
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setReviewComment(array $reviewComment = array())
    {
        // validation for constraint: array
        if ('' !== ($reviewCommentArrayErrorMessage = self::validateReviewCommentForArrayConstraintsFromSetReviewComment($reviewComment))) {
            throw new \InvalidArgumentException($reviewCommentArrayErrorMessage, __LINE__);
        }
        $this->ReviewComment = $reviewComment;
        return $this;
    }
    /**
     * Add item to ReviewComment value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\ReviewCommentType $item
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function addToReviewComment(\rdyescapiacontent\StructType\ReviewCommentType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\ReviewCommentType) {
            throw new \InvalidArgumentException(sprintf('The ReviewComment property can only contain items of type \rdyescapiacontent\StructType\ReviewCommentType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReviewComment[] = $item;
        return $this;
    }
    /**
     * Get ManagerResponse value
     * @return \rdyescapiacontent\StructType\ManagerResponseType[]|null
     */
    public function getManagerResponse()
    {
        return $this->ManagerResponse;
    }
    /**
     * This method is responsible for validating the values passed to the setManagerResponse method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManagerResponse method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateManagerResponseForArrayConstraintsFromSetManagerResponse(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $unitReviewTypeManagerResponseItem) {
            // validation for constraint: itemType
            if (!$unitReviewTypeManagerResponseItem instanceof \rdyescapiacontent\StructType\ManagerResponseType) {
                $invalidValues[] = is_object($unitReviewTypeManagerResponseItem) ? get_class($unitReviewTypeManagerResponseItem) : sprintf('%s(%s)', gettype($unitReviewTypeManagerResponseItem), var_export($unitReviewTypeManagerResponseItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ManagerResponse property can only contain items of type \rdyescapiacontent\StructType\ManagerResponseType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ManagerResponse value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\ManagerResponseType[] $managerResponse
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setManagerResponse(array $managerResponse = array())
    {
        // validation for constraint: array
        if ('' !== ($managerResponseArrayErrorMessage = self::validateManagerResponseForArrayConstraintsFromSetManagerResponse($managerResponse))) {
            throw new \InvalidArgumentException($managerResponseArrayErrorMessage, __LINE__);
        }
        $this->ManagerResponse = $managerResponse;
        return $this;
    }
    /**
     * Add item to ManagerResponse value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\ManagerResponseType $item
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function addToManagerResponse(\rdyescapiacontent\StructType\ManagerResponseType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\ManagerResponseType) {
            throw new \InvalidArgumentException(sprintf('The ManagerResponse property can only contain items of type \rdyescapiacontent\StructType\ManagerResponseType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ManagerResponse[] = $item;
        return $this;
    }
    /**
     * Get Title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->Title;
    }
    /**
     * Set Title value
     * @param string $title
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setTitle($title = null)
    {
        // validation for constraint: string
        if (!is_null($title) && !is_string($title)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($title, true), gettype($title)), __LINE__);
        }
        $this->Title = $title;
        return $this;
    }
    /**
     * Get ReviewedDate value
     * @return string|null
     */
    public function getReviewedDate()
    {
        return $this->ReviewedDate;
    }
    /**
     * Set ReviewedDate value
     * @param string $reviewedDate
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setReviewedDate($reviewedDate = null)
    {
        // validation for constraint: string
        if (!is_null($reviewedDate) && !is_string($reviewedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reviewedDate, true), gettype($reviewedDate)), __LINE__);
        }
        $this->ReviewedDate = $reviewedDate;
        return $this;
    }
    /**
     * Get LastUpdated value
     * @return string|null
     */
    public function getLastUpdated()
    {
        return $this->LastUpdated;
    }
    /**
     * Set LastUpdated value
     * @param string $lastUpdated
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setLastUpdated($lastUpdated = null)
    {
        // validation for constraint: string
        if (!is_null($lastUpdated) && !is_string($lastUpdated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastUpdated, true), gettype($lastUpdated)), __LINE__);
        }
        $this->LastUpdated = $lastUpdated;
        return $this;
    }
    /**
     * Get ReviewerID value
     * @return string|null
     */
    public function getReviewerID()
    {
        return $this->ReviewerID;
    }
    /**
     * Set ReviewerID value
     * @param string $reviewerID
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setReviewerID($reviewerID = null)
    {
        // validation for constraint: string
        if (!is_null($reviewerID) && !is_string($reviewerID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reviewerID, true), gettype($reviewerID)), __LINE__);
        }
        $this->ReviewerID = $reviewerID;
        return $this;
    }
    /**
     * Get ReviewerName value
     * @return string|null
     */
    public function getReviewerName()
    {
        return $this->ReviewerName;
    }
    /**
     * Set ReviewerName value
     * @param string $reviewerName
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setReviewerName($reviewerName = null)
    {
        // validation for constraint: string
        if (!is_null($reviewerName) && !is_string($reviewerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reviewerName, true), gettype($reviewerName)), __LINE__);
        }
        $this->ReviewerName = $reviewerName;
        return $this;
    }
    /**
     * Get ReviewerCity value
     * @return string|null
     */
    public function getReviewerCity()
    {
        return $this->ReviewerCity;
    }
    /**
     * Set ReviewerCity value
     * @param string $reviewerCity
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setReviewerCity($reviewerCity = null)
    {
        // validation for constraint: string
        if (!is_null($reviewerCity) && !is_string($reviewerCity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reviewerCity, true), gettype($reviewerCity)), __LINE__);
        }
        $this->ReviewerCity = $reviewerCity;
        return $this;
    }
    /**
     * Get ReviewerState value
     * @return string|null
     */
    public function getReviewerState()
    {
        return $this->ReviewerState;
    }
    /**
     * Set ReviewerState value
     * @param string $reviewerState
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setReviewerState($reviewerState = null)
    {
        // validation for constraint: string
        if (!is_null($reviewerState) && !is_string($reviewerState)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reviewerState, true), gettype($reviewerState)), __LINE__);
        }
        $this->ReviewerState = $reviewerState;
        return $this;
    }
    /**
     * Get ReviewerCountry value
     * @return string|null
     */
    public function getReviewerCountry()
    {
        return $this->ReviewerCountry;
    }
    /**
     * Set ReviewerCountry value
     * @param string $reviewerCountry
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setReviewerCountry($reviewerCountry = null)
    {
        // validation for constraint: string
        if (!is_null($reviewerCountry) && !is_string($reviewerCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reviewerCountry, true), gettype($reviewerCountry)), __LINE__);
        }
        $this->ReviewerCountry = $reviewerCountry;
        return $this;
    }
    /**
     * Get CheckIn value
     * @return string|null
     */
    public function getCheckIn()
    {
        return $this->CheckIn;
    }
    /**
     * Set CheckIn value
     * @param string $checkIn
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setCheckIn($checkIn = null)
    {
        // validation for constraint: string
        if (!is_null($checkIn) && !is_string($checkIn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($checkIn, true), gettype($checkIn)), __LINE__);
        }
        $this->CheckIn = $checkIn;
        return $this;
    }
    /**
     * Get CheckOut value
     * @return string|null
     */
    public function getCheckOut()
    {
        return $this->CheckOut;
    }
    /**
     * Set CheckOut value
     * @param string $checkOut
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setCheckOut($checkOut = null)
    {
        // validation for constraint: string
        if (!is_null($checkOut) && !is_string($checkOut)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($checkOut, true), gettype($checkOut)), __LINE__);
        }
        $this->CheckOut = $checkOut;
        return $this;
    }
    /**
     * Get PropertyManagerRejected value
     * @return bool|null
     */
    public function getPropertyManagerRejected()
    {
        return $this->PropertyManagerRejected;
    }
    /**
     * Set PropertyManagerRejected value
     * @param bool $propertyManagerRejected
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setPropertyManagerRejected($propertyManagerRejected = null)
    {
        // validation for constraint: boolean
        if (!is_null($propertyManagerRejected) && !is_bool($propertyManagerRejected)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($propertyManagerRejected, true), gettype($propertyManagerRejected)), __LINE__);
        }
        $this->PropertyManagerRejected = $propertyManagerRejected;
        return $this;
    }
    /**
     * Get ReservationNumber value
     * @return string|null
     */
    public function getReservationNumber()
    {
        return $this->ReservationNumber;
    }
    /**
     * Set ReservationNumber value
     * @param string $reservationNumber
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public function setReservationNumber($reservationNumber = null)
    {
        // validation for constraint: string
        if (!is_null($reservationNumber) && !is_string($reservationNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reservationNumber, true), gettype($reservationNumber)), __LINE__);
        }
        $this->ReservationNumber = $reservationNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\StructType\UnitReviewType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
